function [oCoords,oX,oY] = coordVals(iImg)
% COORDVALS - Generate a matrix of every coordinate in the input image
%    Assumes the input image is 2D
  fImgSz = size(iImg);
  fx = [1:fImgSz(1)]-ceil(fImgSz(1)/2);
  fy = [1:fImgSz(2)]-ceil(fImgSz(2)/2);
  
  [oX oY oZ] = ndgrid(fx,fy,1);
  
  oCoords = [oX(:) oY(:) oZ(:)]';
