function oProduct = imgMul(i1,i2)
% IMGMUL - Multiplies two matrices of image together
  
%Error check
  if( size(i1,2)~= size(i2,1) )
    error('No. cols in i1 must equal no. rows in i2');
    oProduct=[];
    return;
  end
  
  for c1=1:size(i1,1),
    for c2=1:size(i2,2),
      oProduct{c1,c2} = zeros(size(i1{1}));
      for c3=1:size(i1,2),
        oProduct{c1,c2} = oProduct{c1,c2} + i1{c1,c3}.*i2{c3,c2};
      end
    end
  end
