function oH = jointHist(iTmp,iRef,iBins,iInc)
% JOINTHIST - Generate joint histogram of two images
  
  if nargin < 3
    iBins = [256 256];
  end
  if numel(iBins) == 0
    iBins = floor([max(iTmp(:)) max(iRef(:))]);
  end
  
  fProb = 1/numel(iTmp);
  
  oH = zeros(iBins);
  fImgs = sub2ind(iBins,floor(iTmp+1),floor(iRef+1));
  
  if nargin < 4
    for c1=1:numel(iTmp),
      tr = fImgs(c1);
      oH(tr) = oH(tr) + fProb;
    end
  else  
    iInc = iInc*fProb;
    for c1=1:numel(iTmp),
      tr = fImgs(c1);
      oH(tr) = oH(tr) + iInc(c1);
    end
  end
