function oH = singleHist(iTmp,iBins,iInc)
% SINGLEHIST - Generate joint histogram of two images
  
  if nargin<2
    iBins = 256;
  end
  if numel(iBins) == 0
    iBins = floor(max(iTmp(:)));
  end
  
  fProb = 1/numel(iTmp);
  
  oH = zeros(iBins(1),1);
  
  fImgs = floor(iTmp+1);
  
  if nargin < 3
    for c1=1:numel(iTmp),
      tr = fImgs(c1);
      oH(tr) = oH(tr) + fProb;
    end
  else
    iInc = iInc*fProb;
    for c1=1:numel(iTmp),
      tr = fImgs(c1);
      oH(tr) = oH(tr) + iInc(c1);
    end
  end    

