% oR = warpRect( iX, iShp )
%Finds the iShp sized rectangle warped by iX
function [oR] = warpRect(iX,iShp) 
 
  ix = iShp(1);
  iy = iShp(2);
  Rect = [-ix ix ix -ix; -iy -iy iy iy; 1 1 1 1];
  
  Rot = getR(iX);
  
  oR = Rot*Rect;

%-----------------------------------------------------------------------
function [oR,x,y] = getR(iX)
  
  kSz = size(iX,1);
  x = iX(1)+1; y = iX(2)+1;
  if kSz == 2
    oR = [1 0 x; 0 1 y];
  elseif kSz == 3
    c = cos(iX(3)); s = sin(iX(3));
    oR = [ c s x; -s c y];
  elseif kSz == 4
    c = (1+iX(4)) * cos(iX(3)); s = (1+iX(4)) * sin(iX(3));
    oR = [ c s x; -s c y];
  elseif kSz == 6
    iX(1) = iX(1)+1; iX(4)=iX(4)+1;
    oR = reshape( iX(:), [2 3] );
    x = iX(5); y = iX(6);    
  end
