
%% Load a movie for the demo
cd D:\usr\persDoc\phd\milk\dev\milkTestHarness
load signlady;
mov = double(sign3);
clear sign3;

%% Extract a template;
X = [0 0 0 0 65 85];
SZ = [69 51]+1;
tmp = affRegion(SZ,mov(:,:,1),X);
img = mov(:,:,10);

% Create figure to display movie and create some useful functions
B = [SZ(1)*[-1 1 1 -1]; SZ(2)*[-1 -1 1 1]; 2 2 2 2]/2;
getRect = @(X) [reshape(X,2,3)+[1 0 0; 0 1 0]; 0 0 1] * B;
showRect = @(R) patch(R(2,:),R(1,:),[0 1 0],'FaceAlpha',0.5);
updateRect = @(H,R) set(H,'XData',R(2,:),'YData',R(1,:));

figure(2); 
imagesc(tmp);
colormap(gray(256));
figure(1);
clf;
hImage = image(mov(:,:,1));
colormap(gray(256));
hRect = showRect(getRect(X));

% Track a region in the image
%X = [0 0 0 0 72 85]; %Reset initial position

A = {'mifwds',1}; %Set algorithm to {mifwds/mibwds/ssdfws/ssdbwds, 1,1.5,2};
%1 for HEssian without 2nd order components - most implementations do this
%1.5 for HEssian without 2nd order components sometimes
%2 for HEssian WITH 2nd order components

%This is a very basic tracking algorithm so don't expect good performance
%Simon Bakers Strategic tracker should do a bit better
for frame=2:size(mov,3)
  tic;
  img = mov(:,:,frame);
  X = lmmin(tmp/32,img/32,X,A); %Don't forget to divide by 256/# bins
  set(hImage,'CData',img);
  updateRect(hRect,getRect(X));
  pause(0.01);
  disp([frame toc])
end

%% Use strategic update
 %WIP


%% Do verbose LM min - shows steps taken during optimisation

[a1 a2 a3 a4 a5 a6]=ndgrid(-1:.1:1,-1:.1:1,0,0,90,86);
Xs=[a1(:) a2(:) a3(:) a4(:) a5(:) a6(:) ];
verb.X1=squeeze(a1);
verb.X2=squeeze(a2);
verb.Y12 = reshape( -warts(tmp/32,img/32,Xs',[6 3 1 1 1]), 21,21 );

[a1 a2 a3 a4 a5 a6]=ndgrid(0,0,-1:.1:1,-1:.1:1,90,86);
Xs=[a1(:) a2(:) a3(:) a4(:) a5(:) a6(:) ];
verb.X3=squeeze(a3);
verb.X4=squeeze(a4);
verb.Y34 = reshape( -warts(tmp/32,img/32,Xs',[6 3 1 1 1]), 21,21 );

[a1 a2 a3 a4 a5 a6]=ndgrid(0,0,0,0,90+(-2:.1:2),86+(-2:.1:2));
Xs=[a1(:) a2(:) a3(:) a4(:) a5(:) a6(:) ];
verb.X5=squeeze(a5);
verb.X6=squeeze(a6);
verb.Y56 = reshape( -warts(tmp/32,img/32,Xs',[6 3 1 1 1]), 41,41);

%Run the optimisation
[x y h n] = lmmin(tmp/32,img/32,[0 0 0 0 90 86],{'mifwds',1},verb);