%Looking at optimisation methods

load;

[a1 a2 a3 a4 a5 a6]=ndgrid([-1:.1:1],[-1:.1:1],0,0,79,91);
Xs=[a1(:) a2(:) a3(:) a4(:) a5(:) a6(:) ];
verb.X1=squeeze(a1);
verb.X2=squeeze(a2);
verb.Y12 = reshape( -warts(tmp/32,img/32,Xs',[6 3 1 1 1]), 21,21 );

[a1 a2 a3 a4 a5 a6]=ndgrid(0,0,[-1:.1:1],[-1:.1:1],79,91);
Xs=[a1(:) a2(:) a3(:) a4(:) a5(:) a6(:) ];
verb.X3=squeeze(a3);
verb.X4=squeeze(a4);
verb.Y34 = reshape( -warts(tmp/32,img/32,Xs',[6 3 1 1 1]), 21,21 );

[a1 a2 a3 a4 a5 a6]=ndgrid(0,0,0,0,79+[-2:.1:2],91+[-2:.1:2]);
Xs=[a1(:) a2(:) a3(:) a4(:) a5(:) a6(:) ];
verb.X5=squeeze(a5);
verb.X6=squeeze(a6);
verb.Y56 = reshape( -warts(tmp/32,img/32,Xs',[6 3 1 1 1]), 41,41);

%Run the optimisation
[x y h n] = lmmin(tmp/32,img/32,[0 0 0 0 79+1 91+1],{'mifwds',1},verb);

%Run some speed tests
tic; 
  for c1=1:length(Xs), f = mifwds(tmp/32,img/32,Xs(c1,:)); end;
  time(1) = toc; 
toc;

tic;
  for c1=1:length(Xs), [f,g,h] = mifwds(tmp/32,img/32,Xs(c1,:)); end;
  time(2) = toc;
toc;

tic;
  for c1=1:length(Xs), [f,g,h,h2] = mifwds(tmp/32,img/32,Xs(c1,:)); end;
  time(3) = toc;
toc;

tic;
  for c1=1:length(Xs), f = mibwds(tmp/32,img/32,Xs(c1,:)); end;
  time(4) = toc;
toc;

tic;
  for c1=1:length(Xs), [f,g] = mibwds(tmp/32,img/32,Xs(c1,:)); end;
  time(5) = toc;
toc;

tic;
  for c1=1:length(Xs), [f,g,h] = mibwds(tmp/32,img/32,Xs(c1,:)); end;
  time(6) = toc;
toc;

tic;
  for c1=1:length(Xs), [f,g,h,h2] = mibwds(tmp/32,img/32,Xs(c1,:)); end;
  time(7) = toc;
toc;

tic;
  for c1=1:length(Xs), [f,g,h,h2,h3] = mibwds(tmp/32,img/32,Xs(c1,:)); end;
  time(8) = toc;
toc;

save times time;

%Run some tests: 100 tests in 5 rings around the ground truth
load testSuiteSRMI;

testSuite.radii = [.5 1 1.5 2 3 4];
t.angle = [0:99]/100*2*pi;

testSuite.fradii = [.25 .5 .75 1 1.25 1.5 1.75 2 2.5 3 3.5 4 5];
testSuite.fixedOffsets= kron( testSuite.fradii, [cos(t.angle); sin(t.angle)] );
testSuite.fixedOffsets=cat(1, randn(4,1300)*.03, testSuite.fixedOffsets);
%testSuite.fixedOffsets= reshape( testSuite.fixedOffsets, [6 50 12] );

t.R = testSuite.img{1};
t.Off = testSuite.Offsets;
tstResult.x = [];
tstResult.f = [];
tstResult.n = [];
t.Pz = fspecial('gaussian',5,1);

t.algs1 = {'fwds' 'fwds' 'bwds' 'bwds'};
t.algs2 = [1 2 1 2];

for c3 =1:4
  h = waitbar(0,'ETA: ?');
  t.alg = {t.algs1{c3} t.algs2(c3)};
  t.Ntest = 8*5*length(t.Off);
  t.Ctest = 0;
  tic;
    for c4=1:8
      for c2=1:5
        t.T = testSuite.tmpTx{c4}{c2};
        for c1=1:length(t.Off)
          %t.pos = [0 0 0 0 t.Off(:,c1)'] + [0 0 0 0 1/3+testSuite.warp(:,1)'];
          t.pos = t.Off(:,c1)' + [0 0 0 0 resc.xhi(:,c2,c4)'];
          [t.x t.f t.h t.n] = lmmin( t.T/32, t.R/32, t.pos, t.Pz, t.alg );
          t.Ctest = t.Ctest+1;
          tstResult.x(:,c1,c2,c4) = t.x(:);
          tstResult.f(c1,c2,c4) = t.f;
          tstResult.n(:,c1,c2,c4) = t.n(:);
          t.time = toc;
          t.eta = (t.time / t.Ctest)*(t.Ntest-t.Ctest);
          t.min = floor(t.eta / 60);
          t.sec = floor(t.eta - 60*t.min);
          waitbar(t.Ctest/t.Ntest,h,...
                  ['ETA: ' num2str(t.min) ':' num2str(t.sec) ' - ' ...
                   num2str(floor(t.Ctest/t.Ntest*100)) '%']);
        end
      end
    end
  toc
  close(h);


  if strcmp( t.alg{1}, 'fwds' )
    if t.alg{2}==1
      resTfwd = tstResult;
    else
      resTfwdNewt = tstResult;
    end
  else
    if t.alg{2}==1
      resTbwd = tstResult;
    else
      resTbwdNewt = tstResult;
    end
  end
end
save resT resTfwd resTfwdNewt resTbwd resTbwdNewt;
%Get the ground truth

d = [-2:.2:2];
x = 88.33;
y = 62.33;
for c2=1:10
  [a b] = ndgrid(x+d,y+d);
  f=zeros(size(a));
  for c1=1:numel(a)
    f(c1) = mifwds( t.T/32, t.R/32, [0 0 0 0 a(c1) b(c1)],1 );
  end
  [fhi fi] =max(f(:));
  x=a(fi);
  y=b(fi);
  d=d/2;
end

%Plot the results
res.xyerr = reshape( abs( (res.x(5,:,:)-testSuite.warp(1,1)-1/3).^2 ...
                             +(res.x(6,:,:)-testSuite.warp(2,1)-1/3).^2)...
                        , [50 6 5]);
res.xyerr = sqrt(res.xyerr);


resfwd.xyerr = reshape( abs( (resfwd.x(5,:,:)-testSuite.warp(1,1)-1/3).^2 ...
                             +(resfwd.x(6,:,:)-testSuite.warp(2,1)-1/3).^2)...
                        , [50 6 5]);
resfwd.xyerr = sqrt(resfwd.xyerr);
resbwd.xyerr = reshape( abs( (resbwd.x(5,:,:)-testSuite.warp(1,1)-1/3).^2 ...
                             +(resbwd.x(6,:,:)-testSuite.warp(2,1)-1/3).^2)...
                        , [50 6 5]);
resbwd.xyerr = sqrt(resbwd.xyerr);
resfwdNewt.xyerr = reshape( abs( (resfwdNewt.x(5,:,:)-...
                                  testSuite.warp(1,1)-1/3).^2 ...
                                 +(resfwdNewt.x(6,:,:)-...
                                   testSuite.warp(2,1)-1/3).^2)...
                            , [50 6 5]);
resfwdNewt.xyerr = sqrt(resfwdNewt.xyerr);
resbwdNewt.xyerr = reshape( abs( (resbwdNewt.x(5,:,:)-...
                                  testSuite.warp(1,1)-1/3).^2 ...
                                 +(resbwdNewt.x(6,:,:)-...
                                   testSuite.warp(2,1)-1/3).^2)...
                            , [50 6 5]);
resbwdNewt.xyerr = sqrt(resbwdNewt.xyerr);
resbwdStart.xyerr = reshape( abs( (resbwdStart.x(5,:,:)-...
                                  testSuite.warp(1,1)-1/3).^2 ...
                                 +(resbwdStart.x(6,:,:)-...
                                   testSuite.warp(2,1)-1/3).^2)...
                            , [50 6 5]);
resbwdStart.xyerr = sqrt(resbwdStart.xyerr);

leg = {'r+','bx','go','k.','md','c*'};

figure(1); clf;
subplot(1,2,1);
for c1=1:6, 
  plot([1:5]+c1/10,squeeze(resfwd.xyerr(:,c1,:)),leg{c1}); 
  hold on; 
end
t.axis = axis;
subplot(1,2,2);
for c1=1:6, 
  plot([1:5]+c1/10,squeeze(resbwd.xyerr(:,c1,:)),leg{c1}); 
  hold on; 
end
axis(t.axis);
figure(2);
for c1=1:6, 
  plot([1:5]+c1/10,squeeze(resfwdNewt.xyerr(:,c1,:)),leg{c1}); 
  hold on; 
end
axis(t.axis);
figure(3);
for c1=1:6, 
  plot([1:5]+c1/10,squeeze(resbwdNewt.xyerr(:,c1,:)),leg{c1}); 
  hold on; 
end
axis(t.axis);
figure(4);
for c1=1:6, 
  plot([1:5]+c1/10,squeeze(resbwdStart.xyerr(:,c1,:)),leg{c1}); 
  hold on; 
end
axis(t.axis);

figure;
for c1=1:6, 
  plot([1:5]+c1/10,squeeze(res.xyerr(:,c1,:)),leg{c1}); 
  hold on; 
end

%================================================================
%Run some tests: 100 tests in 5 rings around the ground truth

%Varying binsize

load testSuiteSRMI;

testSuite.radii = [.5 1 1.5 2 3 4];
t.angle = [0:49]/50*2*pi;
testSuite.Offsets = kron( testSuite.radii, [cos(t.angle); sin(t.angle)] );
t.R = testSuite.img{1};
t.Off = testSuite.Offsets;
tstResult.x = [];
tstResult.f = [];
tstResult.n = [];
t.Pz = fspecial('gaussian',5,1);

t.algs1 = {'fwds' 'fwds' 'bwds' 'bwds'};
t.algs2 = [1 2 1 2];

for c3 =1:4
h = waitbar(0,'ETA: ?');
t.alg = {t.algs1{c3},t.algs2(c3)};
t.Ntest = 5*length(t.Off);
t.Ctest = 0;

t.bins =[4 8 16 32 64];
tic;
  for c2=1:5
    t.T = testSuite.tmpTx{1}{3};
    for c1=1:length(t.Off)
      t.pos = [0 0 0 0 t.Off(:,c1)'] + [0 0 0 0 1/3+testSuite.warp(:,1)'];
      [t.x t.f t.h t.n] = lmmin( t.T*t.bins(c2)/256, t.R*t.bins(c2)/256, ...
                                 t.pos, t.Pz, t.alg );
      t.Ctest = t.Ctest+1;
      tstResult.x(:,c1,c2) = t.x(:);
      tstResult.f(c1,c2) = t.f;
      tstResult.n(:,c1,c2) = t.n(:);
      t.time = toc;
      t.eta = (t.time / t.Ctest)*(t.Ntest-t.Ctest);
      t.min = floor(t.eta / 60);
      t.sec = floor(t.eta - 60*t.min);
      waitbar(t.Ctest/t.Ntest,h,...
              ['ETA: ' num2str(t.min) ':' num2str(t.sec) ' - ' ...
               num2str(floor(t.Ctest/t.Ntest*100)) '%']);
    end
  end
toc
close(h);

if strcmp( t.alg{1}, 'fwds' )
  if t.alg{2}==1
    resIfwd = tstResult;
  else
    resIfwdNewt = tstResult;
  end
else
  if t.alg{2}==1
    resIbwd = tstResult;
  else
    resIbwdNewt = tstResult;
  end
end
end

%===================================================================
%Timing tests

%Varying bins size
load testSuiteSRMI;

tx = testSuite.warp(1,1);
ty = testSuite.warp(2,1);
[a1 a2 a3 a4 a5 a6]=ndgrid(0,0,0,0,tx+[-2:.1:2],ty+[-2:.1:2]);
Xs=[a1(:) a2(:) a3(:) a4(:) a5(:) a6(:) ];
tmp = testSuite.tmpTx{1}{3};
img = testSuite.img{1};
for c2=1:5
  tb = 256/t.bins(c2);
  tic; 
    for c1=1:100, [f] = mifwds(tmp/tb,img/tb,Xs(c1,:),1); end; a(1)=toc;
    for c1=1:100, [f g] = mifwds(tmp/tb,img/tb,Xs(c1,:),1); end; a(2)=toc;
    for c1=1:100, [f g h] = mifwds(tmp/tb,img/tb,Xs(c1,:),1); end; a(3)=toc;
    for c1=1:100, [f g h h2] = mifwds(tmp/tb,img/tb,Xs(c1,:),1); end; a(4)=toc;
  toc;
  tstRes.timeFwdI(c2,:) = a/100;
  tic; 
    for c1=1:100, [f] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(1)=toc;
    for c1=1:100, [f g] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(2)=toc;
    for c1=1:100, [f g h] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(3)=toc;
    for c1=1:100, [f g h h2] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(4)=toc;
    for c1=1:100, [f g h h2 h3] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(5)=toc;
  toc; 
  tstRes.timeBwdI(c2,:) = b/100;  
end

%Varying template size
load testSuiteSRMI;

tx = testSuite.warp(1,1);
ty = testSuite.warp(2,1);
[a1 a2 a3 a4 a5 a6]=ndgrid(0,0,0,0,tx+[-2:.1:2],ty+[-2:.1:2]);
Xs=[a1(:) a2(:) a3(:) a4(:) a5(:) a6(:) ];

img = testSuite.img{1};
for c2=1:5
  tmp = testSuite.tmpTx{1}{c2};
  tb = 32;
  tic; 
    for c1=1:100, [f] = mifwds(tmp/tb,img/tb,Xs(c1,:),1); end; a(1)=toc;
    for c1=1:100, [f g] = mifwds(tmp/tb,img/tb,Xs(c1,:),1); end; a(2)=toc;
    for c1=1:100, [f g h] = mifwds(tmp/tb,img/tb,Xs(c1,:),1); end; a(3)=toc;
    for c1=1:100, [f g h h2] = mifwds(tmp/tb,img/tb,Xs(c1,:),1); end; a(4)=toc;
  toc;
  tstRes.timeFwdT(c2,:) = a/100;
  tic; 
    for c1=1:100, [f] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(1)=toc;
    for c1=1:100, [f g] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(2)=toc;
    for c1=1:100, [f g h] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(3)=toc;
    for c1=1:100, [f g h h2] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(4)=toc;
    for c1=1:100, [f g h h2 h3] = mibwds(tmp/tb,img/tb,Xs(c1,:),1); end; b(5)=toc;
  toc; 
  tstRes.timeBwdT(c2,:) = b/100;  
end

[tstRes.timeFwdT(:,1) diff(tstRes.timeFwdT,1,2)]; 
tstRes.timeFwdT2 = [ans(:,1) diff( ans,1,2)];

[tstRes.timeBwdT(:,1) diff(tstRes.timeBwdT,1,2)]; 
tstRes.timeBwdT2 = [ans(:,1) diff( ans,1,2)];

[tstRes.timeFwdI(:,1) diff(tstRes.timeFwdI,1,2)]; 
tstRes.timeFwdI2 = [ans(:,1) diff( ans,1,2)];

[tstRes.timeBwdI(:,1) diff(tstRes.timeBwdI,1,2)]; 
tstRes.timeBwdI2 = [ans(:,1) diff( ans,1,2)];

save timeRes tstRes;

tstRes.timeFwdT2*1000
t.a = tstRes.timeBwdT2;
[t.a(:,1:2) t.a(:,3)+t.a(:,4) t.a(:,5)] *1000

tstRes.timeFwdI2*1000
t.a = tstRes.timeBwdI2;
[t.a(:,1:2) t.a(:,3)+t.a(:,4) t.a(:,5)] *1000

%Measure the shared area between a warped square and itself

t.warp = [0.1 .05 .11 .07 .1 .2];
t.warp2 = [reshape(t.warp,2,3); 0 0 0] + eye(3);
t.corners = .5*[ -1 -1 0; -1 1 0; 1 1 0; 1 -1 0]';
t.wcorners = t.warp2*t.corners;

t.mask = poly2mask( t.wcorners(1,:)*100+50, t.wcorners(2,:)*100+50,...
                    100,100);

t.areai = double(sum(int16(t.mask(:))))/10000;
t.area1 = 1;
t.area2 = abs(polyarea(t.wcorners(1,:),t.wcorners(2,:)));
t.error = 1-min( t.areai/t.area1, t.areai/t.area2 );

%Generate 500 random positions for 6 distances

rand('state',sum(100*clock));
t.a = randn(4,3000)*.03;
t.angle = rand(1,3000)*2*pi;
t.radii = [0.5 1 1.5 2 3 4];
for c1 = 1:6
  t.dist(1,c1*500+[-499:0]) = randn(1,500)*t.radii(c1);
end
t.x = t.dist.*cos(t.angle);
t.y = t.dist.*sin(t.angle);
t.warp = [t.a; t.x; t.y];

testSuite.randomoffsets = t.warp;
save tsta testSuite;

%Pull results together
t.names = {'ta1' 'ta2' 'ta3' 'ta4' 'ta5' 'ta6' 'ta7' 'ta8' };
for c1=1:8
  load(t.names{c1});
  ooRes.Tfwd.x(:,:,:,c1) = oRes.Tfwd.x(:,:,:,c1);
  ooRes.Tfwd.f(:,:,c1) = oRes.Tfwd.f(:,:,c1);
  ooRes.Tfwd.n(:,:,:,c1) = oRes.Tfwd.n(:,:,:,c1);
  ooRes.TfwdNewt.x(:,:,:,c1) = oRes.TfwdNewt.x(:,:,:,c1);
  ooRes.TfwdNewt.f(:,:,c1) = oRes.TfwdNewt.f(:,:,c1);
  ooRes.TfwdNewt.n(:,:,:,c1) = oRes.TfwdNewt.n(:,:,:,c1);
  ooRes.Tbwd.x(:,:,:,c1) = oRes.Tbwd.x(:,:,:,c1);
  ooRes.Tbwd.f(:,:,c1) = oRes.Tbwd.f(:,:,c1);
  ooRes.Tbwd.n(:,:,:,c1) = oRes.Tbwd.n(:,:,:,c1);
  ooRes.TbwdNewt.x(:,:,:,c1) = oRes.TbwdNewt.x(:,:,:,c1);
  ooRes.TbwdNewt.f(:,:,c1) = oRes.TbwdNewt.f(:,:,c1);
  ooRes.TbwdNewt.n(:,:,:,c1) = oRes.TbwdNewt.n(:,:,:,c1);
end

%Mahalanobis distance
%This measure doesn't work well! Try warp overlap instead - too expensive!
for c1=1:8
  t.t = ooRes.Tfwd.x(:,:,:,c1) - repmat([0 0 0 0 testSuite.warp(:,c1)']',...
                                        [1 3000 5]);
  resTfwd.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resTfwd.err(:,:,:,:,c1);
  for c2=1:6
    t.t3(:,1,c2)=[.05 .05 .05 .05 t.radii(c2)/sqrt(2) t.radii(c2)/sqrt(2)];
  end
  t.t2 = repmat(t.t3,[1 500 1 5]);
  resTfwd.md(:,:,:,:,c1) = (2*pi)^-3 * sum(t.t2).^-.5 .* exp(-.5*sum(t.t.^2./t.t2,1));
end

%Warp overlap
resTfwd.ovrlp = [];
for c4=1:8
  for c3=1:5  
    tic; 
    for c2=1:6
      for c1=1:500
        t.sz = size(testSuite.tmpTx{c4}{c3});
        t.x1 = [0 0 0 0 0 0]';
        t.r1 = warpRect(t.x1,t.sz);
        t.r2 = warpRect( resTfwd.err(:,c1,c2,c3,c4), t.sz );
        [t.r3 t.a1 t.a2 t.a3] = overPoly(t.r1,t.r2);
        resTfwd.ovrlp(:,c1,c2,c3,c4) = [t.a1 t.a2 t.a3]';
      end
    end
    toc
  end
end

%Use xy error
resTfwd.xyerr = [];
for c1=1:8
  t.t = ooRes.Tfwd.x(:,:,:,c1) - repmat([0 0 0 0 testSuite.warp(:,c1)']',...
                                        [1 3000 5]);
  resTfwd.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resTfwd.err(:,:,:,:,c1);
  resTfwd.xyerr(1,:,:,:,c1) = sqrt(sum(t.t(5:6,:,:,:,:).^2));
end

std(testSuite.randomoffsets,1,2)


%--------------------------------------------------------------------
%12 Mar - some extra testing

load rescd;

rese = tste_cvgTsmall(1,1,[1:5]);

rese.Tfwd.x = reshape(rese.Tfwd.x,[6 50 12 5]);
rese.Tfwd.f = reshape(rese.Tfwd.f,[1 50 12 5]);
rese.Tfwd.n = reshape(rese.Tfwd.n,[2 50 12 5]);



t.err = rese.Tfwd.x(5:6,:,:) - reshape(repmat(resc.xhi(:,:,1),...
                                              [600 1]),[2 600 5]);
t.xyerr = reshape(sqrt(sum(t.err.^2)),[50 12 5]);

t.err2 = rese2.Tfwd.x(5:6,:,:) - repmat(testSuite.warp(:,1)+1/3,...
                                        [1 300 5]);
t.xyerr2 = reshape(sqrt(sum(t.err2.^2)),[50 6 5]);

t.err3 = rese3.Tfwd.x(5:6,:,:) - repmat(testSuite.warp(:,1)+1/3,...
                                        [1 300 5]);
t.xyerr3 = reshape(sqrt(sum(t.err3.^2)),[50 6 5]);

%--------------------------------------------------------------------
%12 Mar - Times I wrote down for I test

tstTime = [ 553  613 1282  517  617  499  554  496;
           1281 1354 2105 1242 1428 1158 1355 1156;
            494  527  906  451  485  458  400  439;
            653  697 1033  674  693  616  581  645]';
mean(tstTime(:,3)./tstTime(:,1))
std(tstTime(:,3)./tstTime(:,1))

