%Assemble the result together

cd Results

%Pull results together
t.names = {'tb1' 'tb2' 'tb3' 'tb4' 'tb5' 'tb6' 'tb7' 'tb8' };
for c1=1:8
  load(t.names{c1});
  ooRes.Ifwd.x(:,:,:,c1) = oRes.Ifwd.x(:,:,:,c1);
  ooRes.Ifwd.f(:,:,c1) = oRes.Ifwd.f(:,:,c1);
  ooRes.Ifwd.n(:,:,:,c1) = oRes.Ifwd.n(:,:,:,c1);
  ooRes.IfwdNewt.x(:,:,:,c1) = oRes.IfwdNewt.x(:,:,:,c1);
  ooRes.IfwdNewt.f(:,:,c1) = oRes.IfwdNewt.f(:,:,c1);
  ooRes.IfwdNewt.n(:,:,:,c1) = oRes.IfwdNewt.n(:,:,:,c1);
  ooRes.Ibwd.x(:,:,:,c1) = oRes.Ibwd.x(:,:,:,c1);
  ooRes.Ibwd.f(:,:,c1) = oRes.Ibwd.f(:,:,c1);
  ooRes.Ibwd.n(:,:,:,c1) = oRes.Ibwd.n(:,:,:,c1);
  ooRes.IbwdNewt.x(:,:,:,c1) = oRes.IbwdNewt.x(:,:,:,c1);
  ooRes.IbwdNewt.f(:,:,c1) = oRes.IbwdNewt.f(:,:,c1);
  ooRes.IbwdNewt.n(:,:,:,c1) = oRes.IbwdNewt.n(:,:,:,c1);
end

cd .. ;

t.radii = [.5 1 1.5 2 3 4];
load testSuiteSRMI
%=========================================================================
%Mahalanobis distance
%Ihis measure doesn't work well! Iry warp overlap instead
for c1=1:8
  %Fwd
  t.t = ooRes.Ifwd.x(:,:,:,c1) - ...
        repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']', [1 3000 5]);
  resIfwd.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resIfwd.err(:,:,:,:,c1);
  for c2=1:6
    t.t3(:,1,c2)=[.05 .05 .05 .05 t.radii(c2)/sqrt(2) t.radii(c2)/sqrt(2)];
  end
  t.t2 = repmat(t.t3,[1 500 1 5]);
  resIfwd.md(:,:,:,:,c1) = (2*pi)^-3 * sum(t.t2).^-.5 .* ...
      exp(-.5*sum(t.t.^2./t.t2,1));
  
  %FwdNewt
  t.t = ooRes.IfwdNewt.x(:,:,:,c1) - ...
        repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']', [1 3000 5]);
  resIfwdNewt.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resIfwdNewt.err(:,:,:,:,c1);
  for c2=1:6
    t.t3(:,1,c2)=[.05 .05 .05 .05 t.radii(c2)/sqrt(2) t.radii(c2)/sqrt(2)];
  end
  t.t2 = repmat(t.t3,[1 500 1 5]);
  resIfwdNewt.md(:,:,:,:,c1) = (2*pi)^-3 * sum(t.t2).^-.5 .* ...
      exp(-.5*sum(t.t.^2./t.t2,1));
  
  %Bwd
  t.t = ooRes.Ibwd.x(:,:,:,c1) - ...
        repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']', [1 3000 5]);
  resIbwd.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resIbwd.err(:,:,:,:,c1);
  for c2=1:6
    t.t3(:,1,c2)=[.05 .05 .05 .05 t.radii(c2)/sqrt(2) t.radii(c2)/sqrt(2)];
  end
  t.t2 = repmat(t.t3,[1 500 1 5]);
  resIbwd.md(:,:,:,:,c1) = (2*pi)^-3 * sum(t.t2).^-.5 .* ...
      exp(-.5*sum(t.t.^2./t.t2,1));
  
  %BwdNewt
  t.t = ooRes.IbwdNewt.x(:,:,:,c1) - ...
        repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']',[1 3000 5]);
  resIbwdNewt.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resIbwdNewt.err(:,:,:,:,c1);
  for c2=1:6
    t.t3(:,1,c2)=[.05 .05 .05 .05 t.radii(c2)/sqrt(2) t.radii(c2)/sqrt(2)];
  end
  t.t2 = repmat(t.t3,[1 500 1 5]);
  resIbwdNewt.md(:,:,:,:,c1) = (2*pi)^-3 * sum(t.t2).^-.5 .* ...
      exp(-.5*sum(t.t.^2./t.t2,1));

end

%=========================================================================
%XY error

resIfwd.xyerr = [];
resIfwdNewt.xyerr = [];
resIbwd.xyerr = [];
resIbwdNewt.xyerr = [];

for c1=1:8
  %Fwd
  t.t = ooRes.Ifwd.x(:,:,:,c1) - ...
        repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']',[1 3000 5]);
  resIfwd.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resIfwd.err(:,:,:,:,c1);
  resIfwd.xyerr(1,:,:,:,c1) = sqrt(sum(t.t(5:6,:,:,:,:).^2));

  %FwdNewt
  t.t = ooRes.IfwdNewt.x(:,:,:,c1) - ...
        repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']',[1 3000 5]);
  resIfwdNewt.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resIfwdNewt.err(:,:,:,:,c1);
  resIfwdNewt.xyerr(1,:,:,:,c1) = sqrt(sum(t.t(5:6,:,:,:,:).^2));

  %Bwd
  t.t = ooRes.Ibwd.x(:,:,:,c1) - ...
        repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']',[1 3000 5]);
  resIbwd.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resIbwd.err(:,:,:,:,c1);
  resIbwd.xyerr(1,:,:,:,c1) = sqrt(sum(t.t(5:6,:,:,:,:).^2));

  %BwdNewt
  t.t = ooRes.IbwdNewt.x(:,:,:,c1) - ...
        repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']',[1 3000 5]);
  resIbwdNewt.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
  t.t = resIbwdNewt.err(:,:,:,:,c1);
  resIbwdNewt.xyerr(1,:,:,:,c1) = sqrt(sum(t.t(5:6,:,:,:,:).^2));

end

%=========================================================================
%Warp overlap

% $$$ %Fwd
% $$$ resIfwd.ovrlp = [];
% $$$ for c4=1:8
% $$$   for c3=1:5  
% $$$     tic; 
% $$$     for c2=1:6
% $$$       for c1=1:500
% $$$         t.sz = size(testSuite.tmpIx{c4}{c3});
% $$$         t.x1 = [0 0 0 0 0 0]';
% $$$         t.r1 = warpRect(t.x1,t.sz);
% $$$         t.r2 = warpRect( resIfwd.err(:,c1,c2,c3,c4), t.sz );
% $$$         [t.r3 t.a1 t.a2 t.a3] = overPoly(t.r1,t.r2);
% $$$         resIfwd.ovrlp(:,c1,c2,c3,c4) = [t.a1 t.a2 t.a3]';
% $$$       end
% $$$     end
% $$$     toc
% $$$   end
% $$$ end
% $$$ 
% $$$ 
% $$$ %FwdNewt
% $$$ resIfwdNewt.ovrlp = [];
% $$$ for c4=1:8
% $$$   for c3=1:5  
% $$$     tic; 
% $$$     for c2=1:6
% $$$       for c1=1:500
% $$$         t.sz = size(testSuite.tmpIx{c4}{c3});
% $$$         t.x1 = [0 0 0 0 0 0]';
% $$$         t.r1 = warpRect(t.x1,t.sz);
% $$$         t.r2 = warpRect( resIfwdNewt.err(:,c1,c2,c3,c4), t.sz );
% $$$         [t.r3 t.a1 t.a2 t.a3] = overPoly(t.r1,t.r2);
% $$$         resIfwdNewt.ovrlp(:,c1,c2,c3,c4) = [t.a1 t.a2 t.a3]';
% $$$       end
% $$$     end
% $$$     toc
% $$$   end
% $$$ end
% $$$ 
% $$$ %Bwd
% $$$ resIbwd.ovrlp = [];
% $$$ for c4=1:8
% $$$   for c3=1:5  
% $$$     tic; 
% $$$     for c2=1:6
% $$$       for c1=1:500
% $$$         t.sz = size(testSuite.tmpIx{c4}{c3});
% $$$         t.x1 = [0 0 0 0 0 0]';
% $$$         t.r1 = warpRect(t.x1,t.sz);
% $$$         t.r2 = warpRect( resIbwd.err(:,c1,c2,c3,c4), t.sz );
% $$$         [t.r3 t.a1 t.a2 t.a3] = overPoly(t.r1,t.r2);
% $$$         resIbwd.ovrlp(:,c1,c2,c3,c4) = [t.a1 t.a2 t.a3]';
% $$$       end
% $$$     end
% $$$     toc
% $$$   end
% $$$ end
% $$$ 
% $$$ 
% $$$ %BwdNewt
% $$$ resIbwdNewt.ovrlp = [];
% $$$ for c4=1:8
% $$$   for c3=1:5  
% $$$     tic; 
% $$$     for c2=1:6
% $$$       for c1=1:500
% $$$         t.sz = size(testSuite.tmpIx{c4}{c3});
% $$$         t.x1 = [0 0 0 0 0 0]';
% $$$         t.r1 = warpRect(t.x1,t.sz);
% $$$         t.r2 = warpRect( resIbwdNewt.err(:,c1,c2,c3,c4), t.sz );
% $$$         [t.r3 t.a1 t.a2 t.a3] = overPoly(t.r1,t.r2);
% $$$         resIbwdNewt.ovrlp(:,c1,c2,c3,c4) = [t.a1 t.a2 t.a3]';
% $$$       end
% $$$     end
% $$$     toc
% $$$   end
% $$$ end

%===================================================
%Save results
%===================================================
save resIall resIfwd resIbwd resIfwdNewt resIbwdNewt;