%load resI;
%load testSuiteSRMI;
%load tsta;
%load resIall

%rmpath ~/zPers/dev/zuseful
%addpath ~/zPers/dev/zuseful
t.axis = [0 5 0 6];
t.label = {'' '' '' '1.0' '' '' '' '2.0' '' '3.0' '' '4.0' '5.0'};
t.ytick = [0:6];
t.xlabel = 'Initial Offset (pixels)';

figure(1); clf;
subplot(2,2,1);
plot( t.radii, squeeze(mean(mean(resIfwd.xyerr,2),5)) );
set(gca,'XTick',t.radii);
set(gca,'YTick',t.ytick);
set(gca,'XTickLabel',t.label);
title('(a) Forwards Additive');
ylabel('XY Error (pixels)');
axis(t.axis); grid;
%xlabel(t.xlabel);

stdMarker(gca); stdColor(gca); stdLineStyle(gca);

subplot(2,2,2);
plot( t.radii, squeeze(mean(mean(resIbwd.xyerr,2),5)) );
set(gca,'XTick',t.radii);
set(gca,'YTick',t.ytick);
set(gca,'XTickLabel',t.label);
title('(b) Inverse Compositional');
axis(t.axis); grid;
%xlabel(t.xlabel);
%ylabel('XY Error (pixels)');
stdMarker(gca); stdColor(gca); stdLineStyle(gca);

subplot(2,2,3);
plot( t.radii, squeeze(mean(mean(resIfwdNewt.xyerr,2),5)) );
set(gca,'YTick',t.ytick);
set(gca,'XTick',t.radii);
set(gca,'XTickLabel',t.label);
title('(c) Forwards Additive (Full Newton)');
axis(t.axis); grid;
xlabel(t.xlabel);
ylabel('XY Error (pixels)');
stdMarker(gca); stdColor(gca); stdLineStyle(gca);

subplot(2,2,4);
plot( t.radii, squeeze(mean(mean(resIfwd.xyerr,2),5)) );
set(gca,'YTick',t.ytick);
set(gca,'XTick',t.radii);
set(gca,'XTickLabel',t.label);
title('(d) Inverse Compositional (Full Newton)');
axis(t.axis); grid;
xlabel(t.xlabel);
%ylabel('XY Error (pixels)');
stdMarker(gca); stdColor(gca); stdLineStyle(gca);

subplot(2,2,1);
t.h=legend({'4^2 Bins' '8^2 Bins' '16^2 Bins' '32^2 Bins' '64^2 Bins'},...
           'Location','NorthWest','Orientation','Horizontal'); 
%set(t.h,'Color','None');

stdFontSz(gcf,12);


set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperSize',[30 10]);
set(gcf,'PaperPosition',[0 0 30 10]);
print('-depsc2','fig/CvgBinSz.eps');

% $$$ 
% $$$ 
% $$$ leg = {'r+','bx','go','k.','md','c*'};
% $$$ figure(1); clf;
% $$$ subplot(2,2,1);
% $$$ % $$$ for c1=1:6, 
% $$$ % $$$   plot([1:5]'+c1/10,squeeze(resIfwd.xyerr(:,c1,:,1))',leg{c1}); 
% $$$ % $$$   hold on;
% $$$ % $$$ end
% $$$ %bar( squeeze( mean(mean(resIfwd.xyerr,2),5) )');
% $$$ %hold on;
% $$$ %bar( squeeze( std(mean(resIfwd.xyerr,2),1,5) )','b');
% $$$ plot( [.5 1 1.5 2 3 4], squeeze(mean(mean(resIfwd.xyerr,2),5)) );
% $$$ 
% $$$ colormap(summer);
% $$$ axis([0 6 0 5]);
% $$$ title('(a) Forwards Additive');
% $$$ ylabel('XY Error (pixels)');
% $$$ xlabel('Template Width (pixels)');
% $$$ set(gca,'XTickMode','manual');
% $$$ set(gca,'XTick',[1:5]);
% $$$ set(gca,'XTickLabel',[9:2:17]);
% $$$ 
% $$$ subplot(2,2,2);
% $$$ % $$$ for c1=1:6, 
% $$$ % $$$   plot([1:5]+c1/10,squeeze(resIbwd.xyerr(:,c1,:)),leg{c1}); 
% $$$ % $$$   hold on; 
% $$$ % $$$ end
% $$$ bar( squeeze( mean(mean(resIbwd.xyerr,2),5) )');
% $$$ hold on;
% $$$ bar( squeeze( std(mean(resIbwd.xyerr,2),1,5) )','b');
% $$$ colormap(summer);
% $$$ axis([0 6 0 5]);
% $$$ title('(b) Inverse Compositional');
% $$$ xlabel('Template Width (pixels)');
% $$$ ylabel('XY Error (pixels)');
% $$$ set(gca,'XTickMode','manual');
% $$$ set(gca,'XTick',[1:5]);
% $$$ set(gca,'XTickLabel',[9:2:17]);
% $$$ 
% $$$ subplot(2,2,3);
% $$$ % $$$ for c1=1:6, 
% $$$ % $$$   plot([1:5]+c1/10,squeeze(resIfwdNewt.xyerr(:,c1,:)),leg{c1}); 
% $$$ % $$$   hold on; 
% $$$ % $$$ end
% $$$ bar( squeeze( mean(mean(resIfwdNewt.xyerr,2),5) )');
% $$$ hold on;
% $$$ bar( squeeze( std(mean(resIfwdNewt.xyerr,2),1,5) )','b');
% $$$ colormap(summer);
% $$$ axis([0 6 0 5]);
% $$$ title('(c) Forwards Additive (Full Newton)');
% $$$ xlabel('Template Width (pixels)');
% $$$ ylabel('XY Error (pixels)');
% $$$ set(gca,'XTickMode','manual');
% $$$ set(gca,'XTick',[1:5]);
% $$$ set(gca,'XTickLabel',[9:2:17]);
% $$$ 
% $$$ subplot(2,2,4);
% $$$ % $$$ for c1=1:6, 
% $$$ % $$$   plot([1:5]+c1/10,squeeze(resIbwdNewt.xyerr(:,c1,:)),leg{c1}); 
% $$$ % $$$   hold on; 
% $$$ % $$$ end
% $$$ bar( squeeze( mean(mean(resIbwdNewt.xyerr,2),5) )');
% $$$ hold on;
% $$$ bar( squeeze( std(mean(resIbwdNewt.xyerr,2),1,5) )','b');
% $$$ colormap(summer);
% $$$ axis([0 6 0 5]);
% $$$ title('(d) Inverse Compositional (Full Newton)');
% $$$ xlabel('Template Width (pixels)');
% $$$ ylabel('XY Error (pixels)');
% $$$ set(gca,'XTickMode','manual');
% $$$ set(gca,'XTick',[1:5]);
% $$$ set(gca,'XTickLabel',[9:2:17]);
% $$$ 
% $$$ subplot(2,2,1);
% $$$ t.h = legend({'0.5' '1.0' '1.5' '2.0' '3.0' '4,0'},'Location','NorthWest',...
% $$$        'Orientation','Horizontal');
% $$$ 
% $$$ stdFontSz(gcf,[12 12 10]);
% $$$ 
% $$$ % $$$ myKids = get( t.h,'Children');
% $$$ % $$$ for c=[1:6]
% $$$ % $$$   set( myKids(c*3-2), 'Marker', leg{7-c}(2) );
% $$$ % $$$   set( myKids(c*3+[-2:-1]), 'Color', leg{7-c}(1) );
% $$$ % $$$ end
% $$$ 
% $$$ set(gcf,'PaperUnits','centimeters');
% $$$ set(gcf,'PaperSize',[25 10]);
% $$$ set(gcf,'PaperPosition',[0 0 25 10]);
% $$$ print('-depsc2','fig/CvgIsize.eps');
