load Results/ooRes.mat; %resTall;
load testSuiteSRMI;

resTfwd = ooRes.Tfwd;
resTbwd = ooRes.Tbwd;
resTfwdNewt = ooRes.TfwdNewt;
resTbwdNewt = ooRes.TbwdNewt;
%load resT;
%load testSuiteSRMI;

t.radii = [.25:.25:2 2.5:.5:4 5];
%load rese

%rmpath ~/zPers/dev/zuseful
%addpath ~/zPers/dev/zuseful
t.axis = [0 5 0 6];
t.label = {'' '' '' '1.0' '' '' '' '2.0' '' '3.0' '' '4.0' '5.0'};
t.yticks = [0:6];
t.xlabel = ['Initial Offset (pixels)'];

figure(1); clf;
subplot(2,2,1);
plot( t.radii, squeeze(mean(mean(resTfwd.xyerr,2),5)) );
set(gca,'YTick',t.yticks);
set(gca,'XTick',t.radii);
set(gca,'XTickLabel',t.label);
title('(a) Forwards Additive');
ylabel('XY Error (pixels)');
set(gca,'XLim',[0 5],'YLim',[0 7])
grid;
%xlabel(t.xlabel);

%set(t.h,'Color','None');
stdMarker(gca); stdColor(gca); stdLineStyle(gca);

subplot(2,2,2);
plot( t.radii, squeeze(mean(mean(resTbwd.xyerr,2),5)) );
set(gca,'YTick',t.yticks);
set(gca,'XTick',t.radii);
set(gca,'XTickLabel',t.label);
title('(b) Inverse Compositional');
%xlabel(t.xlabel);
%ylabel('XY Error (pixels)');
set(gca,'XLim',[0 5],'YLim',[0 7])
grid;
stdMarker(gca); stdColor(gca); stdLineStyle(gca);

subplot(2,2,3);
plot( t.radii, squeeze(mean(mean(resTfwdNewt.xyerr,2),5)) );
set(gca,'YTick',t.yticks);
set(gca,'XTick',t.radii);
set(gca,'XTickLabel',t.label);
title('(c) Forwards Additive (Full Newton)');
xlabel(t.xlabel);
ylabel('XY Error (pixels)');
set(gca,'XLim',[0 5],'YLim',[0 7])
grid;
stdMarker(gca); stdColor(gca); stdLineStyle(gca);

subplot(2,2,4);
plot( t.radii, squeeze(mean(mean(resTfwd.xyerr,2),5)) );
set(gca,'YTick',t.yticks);
set(gca,'XTick',t.radii);
set(gca,'XTickLabel',t.label);
title('(d) Inverse Compositional (Full Newton)');
xlabel(t.xlabel);
%ylabel('XY Error (pixels)');
set(gca,'XLim',[0 5],'YLim',[0 7])
grid;
stdMarker(gca); stdColor(gca); stdLineStyle(gca);

subplot(2,2,1);
t.h=legend({'9^2 pixels' '11^2 pixels' '13^2 pixels' '15^2 pixels' ...
            '17^2 pixels'},'Location','NorthWest','Orientation','Horizontal'); 
%set(t.h,'Color','None');
stdFontSz(gcf,18);


set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperSize',[35 14]);
set(gcf,'PaperPosition',[0 0 35 15]);
print('-depsc2','fig/CvgTsize.eps');

% $$$ 
% $$$ 
% $$$ leg = {'r+','bx','go','k.','md','c*'};
% $$$ figure(1); clf;
% $$$ subplot(2,2,1);
% $$$ % $$$ for c1=1:6, 
% $$$ % $$$   plot([1:5]'+c1/10,squeeze(resTfwd.xyerr(:,c1,:,1))',leg{c1}); 
% $$$ % $$$   hold on;
% $$$ % $$$ end
% $$$ %bar( squeeze( mean(mean(resTfwd.xyerr,2),5) )');
% $$$ %hold on;
% $$$ %bar( squeeze( std(mean(resTfwd.xyerr,2),1,5) )','b');
% $$$ plot( [.5 1 1.5 2 3 4], squeeze(mean(mean(resTfwd.xyerr,2),5)) );
% $$$ 
% $$$ colormap(summer);
% $$$ axis([0 6 0 5]);
% $$$ title('(a) Forwards Additive');
% $$$ ylabel('XY Error (pixels)');
% $$$ xlabel('Template Width (pixels)');
% $$$ set(gca,'XTickMode','manual');
% $$$ set(gca,'XTick',[1:5]);
% $$$ set(gca,'XTickLabel',[9:2:17]);
% $$$ 
% $$$ subplot(2,2,2);
% $$$ % $$$ for c1=1:6, 
% $$$ % $$$   plot([1:5]+c1/10,squeeze(resTbwd.xyerr(:,c1,:)),leg{c1}); 
% $$$ % $$$   hold on; 
% $$$ % $$$ end
% $$$ bar( squeeze( mean(mean(resTbwd.xyerr,2),5) )');
% $$$ hold on;
% $$$ bar( squeeze( std(mean(resTbwd.xyerr,2),1,5) )','b');
% $$$ colormap(summer);
% $$$ axis([0 6 0 5]);
% $$$ title('(b) Inverse Compositional');
% $$$ xlabel('Template Width (pixels)');
% $$$ ylabel('XY Error (pixels)');
% $$$ set(gca,'XTickMode','manual');
% $$$ set(gca,'XTick',[1:5]);
% $$$ set(gca,'XTickLabel',[9:2:17]);
% $$$ 
% $$$ subplot(2,2,3);
% $$$ % $$$ for c1=1:6, 
% $$$ % $$$   plot([1:5]+c1/10,squeeze(resTfwdNewt.xyerr(:,c1,:)),leg{c1}); 
% $$$ % $$$   hold on; 
% $$$ % $$$ end
% $$$ bar( squeeze( mean(mean(resTfwdNewt.xyerr,2),5) )');
% $$$ hold on;
% $$$ bar( squeeze( std(mean(resTfwdNewt.xyerr,2),1,5) )','b');
% $$$ colormap(summer);
% $$$ axis([0 6 0 5]);
% $$$ title('(c) Forwards Additive (Full Newton)');
% $$$ xlabel('Template Width (pixels)');
% $$$ ylabel('XY Error (pixels)');
% $$$ set(gca,'XTickMode','manual');
% $$$ set(gca,'XTick',[1:5]);
% $$$ set(gca,'XTickLabel',[9:2:17]);
% $$$ 
% $$$ subplot(2,2,4);
% $$$ % $$$ for c1=1:6, 
% $$$ % $$$   plot([1:5]+c1/10,squeeze(resTbwdNewt.xyerr(:,c1,:)),leg{c1}); 
% $$$ % $$$   hold on; 
% $$$ % $$$ end
% $$$ bar( squeeze( mean(mean(resTbwdNewt.xyerr,2),5) )');
% $$$ hold on;
% $$$ bar( squeeze( std(mean(resTbwdNewt.xyerr,2),1,5) )','b');
% $$$ colormap(summer);
% $$$ axis([0 6 0 5]);
% $$$ title('(d) Inverse Compositional (Full Newton)');
% $$$ xlabel('Template Width (pixels)');
% $$$ ylabel('XY Error (pixels)');
% $$$ set(gca,'XTickMode','manual');
% $$$ set(gca,'XTick',[1:5]);
% $$$ set(gca,'XTickLabel',[9:2:17]);
% $$$ 
% $$$ subplot(2,2,1);
% $$$ t.h = legend({'0.5' '1.0' '1.5' '2.0' '3.0' '4,0'},'Location','NorthWest',...
% $$$        'Orientation','Horizontal');
% $$$ 
% $$$ stdFontSz(gcf,[12 12 10]);
% $$$ 
% $$$ % $$$ myKids = get( t.h,'Children');
% $$$ % $$$ for c=[1:6]
% $$$ % $$$   set( myKids(c*3-2), 'Marker', leg{7-c}(2) );
% $$$ % $$$   set( myKids(c*3+[-2:-1]), 'Color', leg{7-c}(1) );
% $$$ % $$$ end
% $$$ 
% $$$ set(gcf,'PaperUnits','centimeters');
% $$$ set(gcf,'PaperSize',[25 10]);
% $$$ set(gcf,'PaperPosition',[0 0 25 10]);
% $$$ print('-depsc2','fig/CvgTsize.eps');
