load Results/ooRes.mat; %resTall;
load testSuiteSRMI;

resTfwd = ooRes.Tfwd;
resTbwd = ooRes.Tbwd;
resTfwdNewt = ooRes.TfwdNewt;
resTbwdNewt = ooRes.TbwdNewt;

t.axis = [0 6 0 40];
t.label = {'0.25' '0.5' '0.75' '1.0' '1.25' '1.5' '1.75' '2.0' ...
           '2.5' '3.0' '4.0' '5.0'};
t.xTickLabel = {'9^2' '11^2' '13^2' '15^2' '17^2'};
figure(1); clf;

subplot(2,2,1); cla;
bar([1:5]',squeeze( mean(mean(resTfwd.n(1,:,:,:,:),2),5))' ); 
hold on;
bar([1:5]',squeeze( mean(mean(resTfwd.n(2,:,:,:,:),2),5))','b' ); 
colormap summer
axis(t.axis); grid;
title('(a) Forwards Additive');
ylabel('No. Evaluations');
%xlabel('Template Width (pixels)');
set(gca,'XTickMode','manual');
set(gca,'XTick',[1:5]);
set(gca,'XTickLabel',t.xTickLabel);

subplot(2,2,2); cla;
bar([1:5]',squeeze( mean(mean(resTbwd.n(1,:,:,:,:),2),5))' ); 
hold on;
bar([1:5]',squeeze( mean(mean(resTbwd.n(2,:,:,:,:),2),5))','b' ); 
axis(t.axis); grid;
title('(b) Inverse Compositional');
%xlabel('Template Width (pixels)');
%ylabel('No. Evaluations');
set(gca,'XTickMode','manual');
set(gca,'XTick',[1:5]);
set(gca,'XTickLabel',t.xTickLabel);

subplot(2,2,3); cla;
bar([1:5]',squeeze( mean(mean(resTfwdNewt.n(1,:,:,:,:),2),5))' ); 
hold on;
bar([1:5]',squeeze( mean(mean(resTfwdNewt.n(2,:,:,:,:),2),5))','b' ); 
axis(t.axis); grid;
title('(c) Forwards Additive (Full Newton)');
xlabel('Template Width (pixels)');
ylabel('No. Evaluations');
set(gca,'XTickMode','manual');
set(gca,'XTick',[1:5]);
set(gca,'XTickLabel',t.xTickLabel);

subplot(2,2,4); cla;
bar([1:5]',squeeze( mean(mean(resTbwdNewt.n(1,:,:,:,:),2),5))' ); 
hold on;
bar([1:5]',squeeze( mean(mean(resTbwdNewt.n(2,:,:,:,:),2),5))','b' ); 
axis(t.axis); grid;
title('(d) Inverse Compositional (Full Newton)');
xlabel('Template Width (pixels)');
%ylabel('No. Evaluations');
set(gca,'XTickMode','manual');
set(gca,'XTick',[1:5]);
set(gca,'XTickLabel',t.xTickLabel);

subplot(2,2,1);
t.h = legend(t.label,'Location','NorthWest',...
       'Orientation','Horizontal');

stdFontSz(gcf,12);

% $$$ myKids = get( t.h,'Children');
% $$$ for c=[1:6]
% $$$   set( myKids(c*3-2), 'Marker', leg{7-c}(2) );
% $$$   set( myKids(c*3+[-2:-1]), 'Color', leg{7-c}(1) );
% $$$ end

set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperSize',[30 10]);
set(gcf,'PaperPosition',[0 0 30 10]);
print('-depsc2','fig/NevalT.eps');
