%Assemble the result together

cd Results

%Pull results together
t.names = {'te1' 'te2' 'te3' 'te4' 'te5' 'te6' 'te7' 'te8' };
for c1=1:8
  load(t.names{c1});
  rese.Tfwd.x(:,:,:,c1) = oRes.Tfwd.x(:,:,:,c1);
  rese.Tfwd.f(:,:,c1) = oRes.Tfwd.f(:,:,c1);
  rese.Tfwd.n(:,:,:,c1) = oRes.Tfwd.n(:,:,:,c1);
  rese.TfwdNewt.x(:,:,:,c1) = oRes.TfwdNewt.x(:,:,:,c1);
  rese.TfwdNewt.f(:,:,c1) = oRes.TfwdNewt.f(:,:,c1);
  rese.TfwdNewt.n(:,:,:,c1) = oRes.TfwdNewt.n(:,:,:,c1);
  rese.Tbwd.x(:,:,:,c1) = oRes.Tbwd.x(:,:,:,c1);
  rese.Tbwd.f(:,:,c1) = oRes.Tbwd.f(:,:,c1);
  rese.Tbwd.n(:,:,:,c1) = oRes.Tbwd.n(:,:,:,c1);
  rese.TbwdNewt.x(:,:,:,c1) = oRes.TbwdNewt.x(:,:,:,c1);
  rese.TbwdNewt.f(:,:,c1) = oRes.TbwdNewt.f(:,:,c1);
  rese.TbwdNewt.n(:,:,:,c1) = oRes.TbwdNewt.n(:,:,:,c1);
end

cd .. ;

load tsta;
t.radii = testSuite.fradii;

%=========================================================================
%Number of evals

resTfwd.n = reshape(rese.Tfwd.n, [2 100 13 5 8]);
resTfwdNewt.n = reshape(rese.TfwdNewt.n, [2 100 13 5 8]);
resTbwd.n = reshape(rese.Tbwd.n, [2 100 13 5 8]);
resTbwdNewt.n = reshape(rese.TbwdNewt.n, [2 100 13 5 8]);

%=========================================================================
%XY error

resTfwd.err = zeros([6 100 13 5 8]);
resTfwd.xyerr = zeros([1 100 13 5 8]);
resTfwdNewt.err = zeros([6 100 13 5 8]);
resTfwdNewt.xyerr = zeros([1 100 13 5 8]);
resTbwd.err = zeros([6 100 13 5 8]);
resTbwd.xyerr = zeros([1 100 13 5 8]);
resTbwdNewt.err = zeros([6 100 13 5 8]);
resTbwdNewt.xyerr = zeros([1 100 13 5 8]);

load rescd
gtc = cat(1,zeros(4,5,8),resc.xhi);

for c1=1:8
  %Fwd
  t.t = rese.Tfwd.x(:,:,:,c1) - ...
        reshape(repmat(gtc(:,:,c1),[1300 1]),[6 1300 5]);
  resTfwd.err(:,:,:,:,c1) = reshape( t.t, [6 100 13 5]);
  t.t = resTfwd.err(:,:,:,:,c1);
  resTfwd.xyerr(1,:,:,:,c1) = sqrt(sum(t.t(5:6,:,:,:,:).^2));

  %FwdNewt
  t.t = rese.TfwdNewt.x(:,:,:,c1) - ...
        reshape(repmat(gtc(:,:,c1),[1300 1]),[6 1300 5]);
  resTfwdNewt.err(:,:,:,:,c1) = reshape( t.t, [6 100 13 5]);
  t.t = resTfwdNewt.err(:,:,:,:,c1);
  resTfwdNewt.xyerr(1,:,:,:,c1) = sqrt(sum(t.t(5:6,:,:,:,:).^2));

  %Bwd
  t.t = rese.Tbwd.x(:,:,:,c1) - ...
        reshape(repmat(gtc(:,:,c1),[1300 1]),[6 1300 5]);
  resTbwd.err(:,:,:,:,c1) = reshape( t.t, [6 100 13 5]);
  t.t = resTbwd.err(:,:,:,:,c1);
  resTbwd.xyerr(1,:,:,:,c1) = sqrt(sum(t.t(5:6,:,:,:,:).^2));

  %BwdNewt
  t.t = rese.TbwdNewt.x(:,:,:,c1) - ...
        reshape(repmat(gtc(:,:,c1),[1300 1]),[6 1300 5]);
  resTbwdNewt.err(:,:,:,:,c1) = reshape( t.t, [6 100 13 5]);
  t.t = resTbwdNewt.err(:,:,:,:,c1);
  resTbwdNewt.xyerr(1,:,:,:,c1) = sqrt(sum(t.t(5:6,:,:,:,:).^2));

end


  t.t = reshape( rese.Tfwd.x, [6 100 13 5 8] );
  t.t2 = reshape( rese.Tfwd.f, [1 100 13 5 8] );
  [t.hi t.idx] = max(t.t2,[],2);
  [t.a t.b t.c t.d t.e] = ndgrid([1:6],ones(100,1),[1:13],[1:5],[1:8]);
  t.b2 = repmat( t.idx, [6 100 1 1 1]);
  t.sz = size(t.a);
  t.idx2 = sub2ind(t.sz,t.a,t.b2,t.c,t.d,t.e);
  t.t3 = t.t(t.idx2);
  resTfwd.err2 = t.t - t.t3;
  resTfwd.xyerr2 = sqrt(sum(resTfwd.err2(5:6,:,:,:,:).^2));

  t.t = reshape( rese.TfwdNewt.x, [6 100 13 5 8] );
  t.t2 = reshape( rese.TfwdNewt.f, [1 100 13 5 8] );
  [t.hi t.idx] = max(t.t2,[],2);
  [t.a t.b t.c t.d t.e] = ndgrid([1:6],ones(100,1),[1:13],[1:5],[1:8]);
  t.b2 = repmat( t.idx, [6 100 1 1 1]);
  t.sz = size(t.a);
  t.idx2 = sub2ind(t.sz,t.a,t.b2,t.c,t.d,t.e);
  t.t3 = t.t(t.idx2);
  resTfwdNewt.err2 = t.t - t.t3;
  resTfwdNewt.xyerr2 = sqrt(sum(resTfwdNewt.err2(5:6,:,:,:,:).^2));

  t.t = reshape( rese.Tbwd.x, [6 100 13 5 8] );
  t.t2 = reshape( rese.Tbwd.f, [1 100 13 5 8] );
  [t.hi t.idx] = max(t.t2,[],2);
  [t.a t.b t.c t.d t.e] = ndgrid([1:6],ones(100,1),[1:13],[1:5],[1:8]);
  t.b2 = repmat( t.idx, [6 100 1 1 1]);
  t.sz = size(t.a);
  t.idx2 = sub2ind(t.sz,t.a,t.b2,t.c,t.d,t.e);
  t.t3 = t.t(t.idx2);
  resTbwd.err2 = t.t - t.t3;
  resTbwd.xyerr2 = sqrt(sum(resTbwd.err2(5:6,:,:,:,:).^2));

  t.t = reshape( rese.TbwdNewt.x, [6 100 13 5 8] );
  t.t2 = reshape( rese.TbwdNewt.f, [1 100 13 5 8] );
  [t.hi t.idx] = max(t.t2,[],2);
  [t.a t.b t.c t.d t.e] = ndgrid([1:6],ones(100,1),[1:13],[1:5],[1:8]);
  t.b2 = repmat( t.idx, [6 100 1 1 1]);
  t.sz = size(t.a);
  t.idx2 = sub2ind(t.sz,t.a,t.b2,t.c,t.d,t.e);
  t.t3 = t.t(t.idx2);
  resTbwdNewt.err2 = t.t - t.t3;
  resTbwdNewt.xyerr2 = sqrt(sum(resTbwdNewt.err2(5:6,:,:,:,:).^2));


% $$$ %=========================================================================
% $$$ %Mahalanobis distance
% $$$ %This measure doesn't work well! Try warp overlap instead
% $$$ for c1=1:8
% $$$   %Fwd
% $$$   t.t = ooRes.Tfwd.x(:,:,:,c1) - ...
% $$$         repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']', [1 3000 5]);
% $$$   resTfwd.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
% $$$   t.t = resTfwd.err(:,:,:,:,c1);
% $$$   for c2=1:6
% $$$     t.t3(:,1,c2)=[.05 .05 .05 .05 t.radii(c2)/sqrt(2) t.radii(c2)/sqrt(2)];
% $$$   end
% $$$   t.t2 = repmat(t.t3,[1 500 1 5]);
% $$$   resTfwd.md(:,:,:,:,c1) = (2*pi)^-3 * sum(t.t2).^-.5 .* ...
% $$$       exp(-.5*sum(t.t.^2./t.t2,1));
% $$$   
% $$$   %FwdNewt
% $$$   t.t = ooRes.TfwdNewt.x(:,:,:,c1) - ...
% $$$         repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']', [1 3000 5]);
% $$$   resTfwdNewt.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
% $$$   t.t = resTfwdNewt.err(:,:,:,:,c1);
% $$$   for c2=1:6
% $$$     t.t3(:,1,c2)=[.05 .05 .05 .05 t.radii(c2)/sqrt(2) t.radii(c2)/sqrt(2)];
% $$$   end
% $$$   t.t2 = repmat(t.t3,[1 500 1 5]);
% $$$   resTfwdNewt.md(:,:,:,:,c1) = (2*pi)^-3 * sum(t.t2).^-.5 .* ...
% $$$       exp(-.5*sum(t.t.^2./t.t2,1));
% $$$   
% $$$   %Bwd
% $$$   t.t = ooRes.Tbwd.x(:,:,:,c1) - ...
% $$$         repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']', [1 3000 5]);
% $$$   resTbwd.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
% $$$   t.t = resTbwd.err(:,:,:,:,c1);
% $$$   for c2=1:6
% $$$     t.t3(:,1,c2)=[.05 .05 .05 .05 t.radii(c2)/sqrt(2) t.radii(c2)/sqrt(2)];
% $$$   end
% $$$   t.t2 = repmat(t.t3,[1 500 1 5]);
% $$$   resTbwd.md(:,:,:,:,c1) = (2*pi)^-3 * sum(t.t2).^-.5 .* ...
% $$$       exp(-.5*sum(t.t.^2./t.t2,1));
% $$$   
% $$$   %BwdNewt
% $$$   t.t = ooRes.TbwdNewt.x(:,:,:,c1) - ...
% $$$         repmat([0 0 0 0 1/3+testSuite.warp(:,c1)']',[1 3000 5]);
% $$$   resTbwdNewt.err(:,:,:,:,c1) = reshape( t.t, [6 500 6 5]);
% $$$   t.t = resTbwdNewt.err(:,:,:,:,c1);
% $$$   for c2=1:6
% $$$     t.t3(:,1,c2)=[.05 .05 .05 .05 t.radii(c2)/sqrt(2) t.radii(c2)/sqrt(2)];
% $$$   end
% $$$   t.t2 = repmat(t.t3,[1 500 1 5]);
% $$$   resTbwdNewt.md(:,:,:,:,c1) = (2*pi)^-3 * sum(t.t2).^-.5 .* ...
% $$$       exp(-.5*sum(t.t.^2./t.t2,1));
% $$$ 
% $$$ end

%=========================================================================
%Warp overlap

% $$$ %Fwd
% $$$ resTfwd.ovrlp = [];
% $$$ for c4=1:8
% $$$   for c3=1:5  
% $$$     tic; 
% $$$     for c2=1:6
% $$$       for c1=1:500
% $$$         t.sz = size(testSuite.tmpTx{c4}{c3});
% $$$         t.x1 = [0 0 0 0 0 0]';
% $$$         t.r1 = warpRect(t.x1,t.sz);
% $$$         t.r2 = warpRect( resTfwd.err(:,c1,c2,c3,c4), t.sz );
% $$$         [t.r3 t.a1 t.a2 t.a3] = overPoly(t.r1,t.r2);
% $$$         resTfwd.ovrlp(:,c1,c2,c3,c4) = [t.a1 t.a2 t.a3]';
% $$$       end
% $$$     end
% $$$     toc
% $$$   end
% $$$ end
% $$$ 
% $$$ 
% $$$ %FwdNewt
% $$$ resTfwdNewt.ovrlp = [];
% $$$ for c4=1:8
% $$$   for c3=1:5  
% $$$     tic; 
% $$$     for c2=1:6
% $$$       for c1=1:500
% $$$         t.sz = size(testSuite.tmpTx{c4}{c3});
% $$$         t.x1 = [0 0 0 0 0 0]';
% $$$         t.r1 = warpRect(t.x1,t.sz);
% $$$         t.r2 = warpRect( resTfwdNewt.err(:,c1,c2,c3,c4), t.sz );
% $$$         [t.r3 t.a1 t.a2 t.a3] = overPoly(t.r1,t.r2);
% $$$         resTfwdNewt.ovrlp(:,c1,c2,c3,c4) = [t.a1 t.a2 t.a3]';
% $$$       end
% $$$     end
% $$$     toc
% $$$   end
% $$$ end
% $$$ 
% $$$ %Bwd
% $$$ resTbwd.ovrlp = [];
% $$$ for c4=1:8
% $$$   for c3=1:5  
% $$$     tic; 
% $$$     for c2=1:6
% $$$       for c1=1:500
% $$$         t.sz = size(testSuite.tmpTx{c4}{c3});
% $$$         t.x1 = [0 0 0 0 0 0]';
% $$$         t.r1 = warpRect(t.x1,t.sz);
% $$$         t.r2 = warpRect( resTbwd.err(:,c1,c2,c3,c4), t.sz );
% $$$         [t.r3 t.a1 t.a2 t.a3] = overPoly(t.r1,t.r2);
% $$$         resTbwd.ovrlp(:,c1,c2,c3,c4) = [t.a1 t.a2 t.a3]';
% $$$       end
% $$$     end
% $$$     toc
% $$$   end
% $$$ end
% $$$ 
% $$$ 
% $$$ %BwdNewt
% $$$ resTbwdNewt.ovrlp = [];
% $$$ for c4=1:8
% $$$   for c3=1:5  
% $$$     tic; 
% $$$     for c2=1:6
% $$$       for c1=1:500
% $$$         t.sz = size(testSuite.tmpTx{c4}{c3});
% $$$         t.x1 = [0 0 0 0 0 0]';
% $$$         t.r1 = warpRect(t.x1,t.sz);
% $$$         t.r2 = warpRect( resTbwdNewt.err(:,c1,c2,c3,c4), t.sz );
% $$$         [t.r3 t.a1 t.a2 t.a3] = overPoly(t.r1,t.r2);
% $$$         resTbwdNewt.ovrlp(:,c1,c2,c3,c4) = [t.a1 t.a2 t.a3]';
% $$$       end
% $$$     end
% $$$     toc
% $$$   end
% $$$ end

%===================================================
%Save results
%===================================================
%save resTall resTfwd resTbwd resTfwdNewt resTbwdNewt;