%Convergence Testing function for BMVC paper

function oRes = tstb_cvgI(iAlg,iTset,iBinSz,iFile,iQuit)
  
  cd ~/zPers/dev/v_bmvaplay/fns;
  
  load tsta;
  load rescd;
  
  t.algs1 = {'fwds' 'fwds' 'bwds' 'bwds'};
  t.algs2 = [1 2 1 2];
  t.bins = [64 32 16 8 4];
  t.Off = testSuite.randomoffsets;
  t.Pz = 1;
  t.percent = 0;
  for c3 =iAlg
    t.alg = {t.algs1{c3} t.algs2(c3)};
    t.Ntest = numel(iTset)*numel(iBinSz)*length(t.Off);
    t.Ctest = 0;
    tic;
      for c4=iTset
        t.R = testSuite.img{c4};
        t.T = testSuite.tmpTx{c4}{4}; %15x15
        for c2=iBinSz
          nb = t.bins(c2);
          for c1=1:length(t.Off)
            %t.pos = t.Off(:,c1)' +[0 0 0 0 1/3+testSuite.warp(:,c4)'];
            t.pos = t.Off(:,c1)' + [0 0 0 0 resd.xhi(:,c2,c4)'];
            [t.x t.f t.h t.n] = lmmin( t.T/nb, t.R/nb, t.pos, t.Pz, t.alg );
            t.Ctest = t.Ctest+1;
            tstResult.x(:,c1,c2,c4) = t.x(:);
            tstResult.f(c1,c2,c4) = t.f;
            tstResult.n(:,c1,c2,c4) = t.n(:);

            t.text = [num2str(c3) ' ' num2str(c4) ' ' num2str(c2)];
            t.percent = myTimer(t.Ctest,t.Ntest,t.percent,t.text);
          end
        end
      end
    toc

    if strcmp( t.alg{1}, 'fwds' )
      if t.alg{2}==1
        oRes.Ifwd = tstResult;
      else
        oRes.IfwdNewt = tstResult;
      end
    else
      if t.alg{2}==1
        oRes.Ibwd = tstResult;
      else
        oRes.IbwdNewt = tstResult;
      end
    end
  end

  if exist('iFile','var')
    if numel(iFile)>0
      save(iFile,'oRes','iAlg','iTset','iBinSz');
    end
  end
  
  if exist('iQuit','var')
    if true==iQuit
      quit;
    end
  end
  